module LifenFhir
  class Address < Element

    attribute :lines, [String]
    attribute :postal_code, String
    attribute :city, String
    attribute :country, String

    def attributes_from_json(json)
      self.lines = Array(json.fetch("line"))

      self.postal_code = json.fetch("postalCode")

      self.city = json.fetch("city")

      self
    end

    def fhir_payload
      {
        "line": lines,
        "city": city,
        "postalCode": postal_code,
        "country": country
      }
    end

  end
end
