module LifenFhir
  class Category < Base

    CODES = ["MEDICAL_REPORT", "MESSAGE", "MEDICATION_ORDER", "REFERRAL_REQUEST", "OTHER"]

    attribute :code, String, default: "MEDICAL_REPORT"

    def fhir_payload
      raise Error.new(message: "Invalid category: code must be in the authorized values") if !valid?

      {
        coding: [
           {
              system: "http://honestica.com/fhir/communication/category",
              code: code
           }
        ]
      }
    end

    def attributes_from_json(json)
      self.code = Array(json["coding"]).first.fetch "code"

      self
    end

    def valid?
      CODES.include? code
    end

  end
end
