module LifenFhir
  class Configuration

    attr_accessor :site

    attr_accessor :application_access_token

    attr_accessor :proxy_url

    # Logger used by Lifen FHIR. In Rails, this is the Rails logger, otherwise
    # Lifen FHIR provides its own LifenFhir::Logger.
    attr_accessor :logger

    def initialize
      self.logger = ::LifenFhir::Logger.new(STDOUT)
    end

    def site=(url)
      if !/(.*)\/$/.match(url)
        raise Error.new(message: "Invalid 'site' provided in configuration: '#{url}', a trailing slash is missing")
      end

      @site = url
    end
  end

  def self.configuration
    @configuration ||= Configuration.new
  end

  def self.configure
    yield(configuration) if block_given?
  end
end
